<template>
    <div class="big-win-container relative rounded-lg overflow-hidden" :class="{ 'big-win-mobile': isMobile }">
        <div class="relative w-[227px] h-[227px] top-part">
            <img class="object-cover h-full w-full rounded-tl-lg rounded-tr-lg" v-lazy="backgroundImage" alt="">
            <div class="absolute top-0 bg-[#FFA337] uppercase w-[92px] text-center font-bold text-white big-win-text">{{ $t('Big Win') }}</div>
            <div class="absolute bottom-0 flex left-2 items-center text-white user-row">
                <img class="object-contain rounded-lg" :class="isMobile ? 'h-4 w-4' : 'h-[30px] w-[30px] mr-1'" v-lazy="getAssetImage(`assets/theme/playful/images/icon-user.svg`)" alt="">
                <span class="text-sm font-bold" :class="!isDisappear ? 'fade-enter-active' : 'fade-leave-active'">{{ data.Name }}</span>
            </div>
        </div>
        <div class="bg-primary flex rounded-b-lg items-center px-2 text-white amount-row">
            <div class="flex items-center">
                <img class="object-contain  rounded-lg " v-lazy="getAssetImage(`assets/theme/playful/images/gold-coin.svg`)" alt="">
                <span class="text-sm font-bold" :class="!isDisappear ? 'fade-enter-active' : 'fade-leave-active'">{{ data.Amount }}</span>
            </div>
        </div>
    </div>
</template>

<script lang="ts" setup>
import { store } from '~~/store';
import numberFormatHelper from '~~/utils/formatHelpers/numberFormatHelper';

defineProps<{
    backgroundImage?: string 
}>()

const { getAssetImage } = commonHelper;
const isDisappear = ref(false);

const isMobile = !useIsDesktop();

const randomizeName = () => {
  const letters = 'ABCDEFGHIJKLMNOPQRSTUVWXYZ';
  let name = '';

  for (let i = 0; i < 2; i++) {
    name += letters.charAt(Math.floor(Math.random() * letters.length));
  }

  name += '****';

  for (let i = 0; i < 2; i++) {
    name += Math.floor(Math.random() * 10);
  }

  return name;
}

const revenueRange: Record<string, {min: number, max: number}> = {
    AED: {
        max: 11017,
        min: 3672,
    },
    AUD: {
        max: 4270,
        min: 1423,
    },
    CAD: {
        max: 3870,
        min: 1290,
    },
    CHF: {
        max: 3300,
        min: 1100,
    },
    CNY: {
        max: 19110,
        min: 6370,
    },
    EUR: {
        max: 2658,
        min: 886,
    },
    GBP: {
        max: 2298,
        min: 766,
    },
    HKD: {
        max: 23400,
        min: 7800,
    },
    IDR: {
        max: 46511550,
        min: 15503850,
    },
    JPY: {
        max: 346200,
        min: 115400,
    },
    KRW: {
        max: 3000000,
        min: 1000000,
    },
    LAK: {
        max: 27000000,
        min: 9000000,
    },
    MMK: {
        max: 45000000,
        min: 15000000,
    },
    MYR: {
        max: 3150,
        min: 1050,
    },
    NOK: {
        max: 26640,
        min: 8880,
    },
    NZD: {
        max: 1449,
        min: 4347,
    },
    SEK: {
        max: 26280,
        min: 8760,
    },
    THB: {
        max: 99000,
        min: 33000,
    },
    TMP: {
        max: 2250000,
        min: 750000,
    },
    UCC: {
        max: 3000,
        min: 1000,
    },
    VND: {
        max: 3000000,
        min: 1000000,
    },
    ZAR: {
        max: 43740,
        min: 14580,
    },
    USD: {
        max: 1000,
        min: 3000,
    }
};

const currency = computed(() => store.state.currency);

const randomizeAmount = () => {
  const currencyCode = currency.value

  if (revenueRange.hasOwnProperty(currencyCode)) {
    const { min, max } = revenueRange[currencyCode];
    const amount = Math.random() * (max - min) + min;
    const randomDecimal = Math.floor(Math.random() * 100);
    const formattedAmount = (amount + randomDecimal / 100).toFixed(2);
    return numberFormatHelper.addAccountingFormatWithoutRoundUp(Number(formattedAmount), 2);
  }
  const { min, max } = revenueRange['USD'];
  const amount = Math.random() * (max - min) + min;
  const randomDecimal = Math.floor(Math.random() * 100);
  const formattedAmount = (amount + randomDecimal / 100).toFixed(2);

  return numberFormatHelper.addAccountingFormatWithoutRoundUp(Number(formattedAmount), 2);
}
const data = ref({
    Name: '',
    Amount: '',
  }
);

const randomizeData = async () => {
    isDisappear.value = true;
    await nextTick();
    await new Promise(resolve => setTimeout(resolve, 200));
    data.value = {
        Name: randomizeName(),
        Amount: randomizeAmount()
    };
    isDisappear.value = false;
}

const interval = Math.floor(Math.random() * 3500) + 1000;
randomizeData();
setInterval(randomizeData, interval);
</script>

<style lang="scss">
</style>

<style scoped lang="scss">

.big-win-container {
    @media screen and (max-width: 360px) {
        .top-part {
            width: 104px;
            height: 128px;
        }
        min-width: 104px;
    }
    @media screen and (min-width: 361px) {
        .top-part {
            height: 104px;
            width: 128px;
        }
        min-width: 128px;
    }
    @media screen and (min-width: 584px) {
        .top-part {
            width: 227px;
            height: 267px;
        }
        min-width: 227px;
    }
    @media screen and (min-width: 960px) {
        .top-part {
            width: 227px;
            height: 267px;
        }
        min-width: 227px;
    }

 .big-win-text {
    border-radius: 0px 0px 20.2px 0px;
    color: #FFF;
    font-family: Roboto;
    font-size: 16px;
    font-style: normal;
    font-weight: 700;
    line-height: normal;
    letter-spacing: 0.32px;
    min-height: 32px;
    width: 92px;
    display: flex;
    align-items: center;
    justify-content: center;
 }

 .user-row,
 .amount-row {
     height: 40px;
     img {
        margin-right: 4px;
     }
 }
 
  &.big-win-mobile {
    width: 104px !important;
    max-width: 104px;
    min-width: 104px;

    .big-win-text {
        border-radius: 0px 0px 9.244px 0px;
        color: #FFF;
        font-family: Roboto;
        font-size: 12px;
        font-style: normal;
        font-weight: 700;
        letter-spacing: 0.24px;
        width: 60px;
        min-height: 16px;
        text-align: center;
    }

    // .top-part {
    //   width: 104px !important;
    //   height: 104px !important;
    // }

    .user-row {
     height: 24px;
     padding: 0 4px;

      img {
        width: 16px;
        height: 16px;
      }
    }

    .amount-row {
        height: 24px;
        padding: 0 4px;

        img {
            width: 16px;
            height: 16px;
        }
    }
  }
}

.fade-enter-active {
  animation: fadeInFromBottom 500ms ease-in-out;
}

.fade-leave-active {
  animation: fadeUpFromBottom 500ms ease-in-out;
}

@keyframes fadeInFromBottom {
  0% {
    opacity: 0;
    transform: translateY(20px);
  }
  100% {
    opacity: 1;
    transform: translateY(0);
  }
}
@keyframes fadeUpFromBottom {
  0% {
    opacity: 1;
    transform: translateY(0);
  }
  100% {
    opacity: 0;
    transform: translateY(20px);
  }
}
</style>